/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.sqlclient;

import java.util.Map;
import rx.Observable;
import rx.Single;

/**
 * Represents which kind the property is.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.sqlclient.PropertyKind original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.sqlclient.PropertyKind.class)
public class PropertyKind<T> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    PropertyKind that = (PropertyKind) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<PropertyKind> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new PropertyKind((io.vertx.sqlclient.PropertyKind) obj),
    PropertyKind::getDelegate
  );

  private final io.vertx.sqlclient.PropertyKind<T> delegate;
  public final io.vertx.lang.rx.TypeArg<T> __typeArg_0;
  
  public PropertyKind(io.vertx.sqlclient.PropertyKind delegate) {
    this.delegate = delegate;
    this.__typeArg_0 = io.vertx.lang.rx.TypeArg.unknown();  }

  public PropertyKind(io.vertx.sqlclient.PropertyKind delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0) {
    this.delegate = delegate;
    this.__typeArg_0 = typeArg_0;
  }

  public io.vertx.sqlclient.PropertyKind getDelegate() {
    return delegate;
  }


  public static <T>PropertyKind<T> newInstance(io.vertx.sqlclient.PropertyKind arg) {
    return arg != null ? new PropertyKind<T>(arg) : null;
  }

  public static <T>PropertyKind<T> newInstance(io.vertx.sqlclient.PropertyKind arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T) {
    return arg != null ? new PropertyKind<T>(arg, __typeArg_T) : null;
  }
}
