/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.sqlclient;

import java.util.Map;
import rx.Observable;
import rx.Single;
import java.util.List;

/**
 * A set of rows.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.sqlclient.RowSet original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.sqlclient.RowSet.class)
public class RowSet<R> extends io.vertx.rxjava.sqlclient.SqlResult<io.vertx.rxjava.sqlclient.RowSet<R>> implements java.lang.Iterable<R> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    RowSet that = (RowSet) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<RowSet> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new RowSet((io.vertx.sqlclient.RowSet) obj),
    RowSet::getDelegate
  );

  private final io.vertx.sqlclient.RowSet<R> delegate;
  public final io.vertx.lang.rx.TypeArg<R> __typeArg_0;
  
  public RowSet(io.vertx.sqlclient.RowSet delegate) {
    super(delegate);
    this.delegate = delegate;
    this.__typeArg_0 = io.vertx.lang.rx.TypeArg.unknown();  }

  public RowSet(io.vertx.sqlclient.RowSet delegate, io.vertx.lang.rx.TypeArg<R> typeArg_0) {
    super(delegate);
    this.delegate = delegate;
    this.__typeArg_0 = typeArg_0;
  }

  public io.vertx.sqlclient.RowSet getDelegate() {
    return delegate;
  }

  /**
   * Get the result value.
   * @return the result
   */
  public io.vertx.rxjava.sqlclient.RowSet<R> value() { 
    io.vertx.rxjava.sqlclient.RowSet<R> ret = io.vertx.rxjava.sqlclient.RowSet.newInstance(delegate.value(), __typeArg_0);
    return ret;
  }

  public io.vertx.rxjava.sqlclient.RowIterator<R> iterator() { 
    io.vertx.rxjava.sqlclient.RowIterator<R> ret = io.vertx.rxjava.sqlclient.RowIterator.newInstance(delegate.iterator(), __typeArg_0);
    return ret;
  }

  public io.vertx.rxjava.sqlclient.RowSet<R> next() { 
    io.vertx.rxjava.sqlclient.RowSet<R> ret = io.vertx.rxjava.sqlclient.RowSet.newInstance(delegate.next(), __typeArg_0);
    return ret;
  }


  public static <R>RowSet<R> newInstance(io.vertx.sqlclient.RowSet arg) {
    return arg != null ? new RowSet<R>(arg) : null;
  }

  public static <R>RowSet<R> newInstance(io.vertx.sqlclient.RowSet arg, io.vertx.lang.rx.TypeArg<R> __typeArg_R) {
    return arg != null ? new RowSet<R>(arg, __typeArg_R) : null;
  }
}
